//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3DAF013D01CC.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3DAF013D01CC.cm

//## begin module%3DAF013D01CC.cp preserve=no
//## end module%3DAF013D01CC.cp

//## Module: PlotRatio%3DAF013D01CC; Package body
//## Subsystem: XSPlot::Commands%3DA1AFD101BF
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Commands/PlotRatio.cxx

//## begin module%3DAF013D01CC.additionalIncludes preserve=no
//## end module%3DAF013D01CC.additionalIncludes

//## begin module%3DAF013D01CC.includes preserve=yes
#include <XSPlot/Plot/CreateBinnedPlotGroups.h>
#include <XSPlot/Plot/PlotGroup.h>
#include <XSPlot/Plot/PlotSettings.h>
#include <XSPlot/Plot/PlotStyle.h>
#include <XSPlot/Plot/PlotTypes.h>
//## end module%3DAF013D01CC.includes

// PlotRatio
#include <XSPlot/Commands/PlotRatio.h>
//## begin module%3DAF013D01CC.declarations preserve=no
//## end module%3DAF013D01CC.declarations

//## begin module%3DAF013D01CC.additionalDeclarations preserve=yes
//## end module%3DAF013D01CC.additionalDeclarations


// Class PlotRatio 

PlotRatio::PlotRatio()
  //## begin PlotRatio::PlotRatio%3DAEFC6300E1_const.hasinit preserve=no
  //## end PlotRatio::PlotRatio%3DAEFC6300E1_const.hasinit
  //## begin PlotRatio::PlotRatio%3DAEFC6300E1_const.initialization preserve=yes
  : PlotCommand("ratio", new CreateBinnedPlotGroups(false,false))
  //## end PlotRatio::PlotRatio%3DAEFC6300E1_const.initialization
{
  //## begin PlotRatio::PlotRatio%3DAEFC6300E1_const.body preserve=yes
   isDataRequired(true);
   isActiveModelRequired(true);
   isDivisibleByArea(false);
   addCompLevel(0);
   isBackgroundApplicable(false);
   
   PlotAttributes styles;
   styles.symbolStyle = PlotCommand::standardDataStyle();
   styles.lineStyle = PlotStyle::NONE;
   setStyleMap(PlotStyle::DATA, styles);
  //## end PlotRatio::PlotRatio%3DAEFC6300E1_const.body
}


PlotRatio::~PlotRatio()
{
  //## begin PlotRatio::~PlotRatio%3DAEFC6300E1_dest.body preserve=yes
  //## end PlotRatio::~PlotRatio%3DAEFC6300E1_dest.body
}



//## Other Operations (implementation)
void PlotRatio::manipulate (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotRatio::manipulate%4B295B520371.body preserve=yes
   const Real NO_VAL = settings.badDataValue();
   for (size_t i=0; i<plotGroups.size(); ++i)
   {
      PlotGroup* pg = plotGroups[i];
      const size_t nPts = pg->n;
      std::vector<Real>& data  = pg->yData.data;
      const std::vector<Real>& model  = pg->model[0].data;
      for (size_t j=0; j<nPts; ++j)
      {
         if (model[j] == 0.0)
         {
            data[j] = NO_VAL;
         }
         else
         {
            data[j] /= model[j];
         }
      }
      // Can't assume yData errors exist.  They won't if this is 
      // following an icounts plot.
      if (pg->yData.errors.size())
      {
         std::vector<Real>& error = pg->yData.errors[0];
         for (size_t j=0; j<nPts; ++j)
         {
            if (model[j] == 0.0)
            {
               error[j] = NO_VAL;
            }
            else
            {
               error[j] /= model[j];
            }
         }
      }
   }
  //## end PlotRatio::manipulate%4B295B520371.body
}

void PlotRatio::setRanges (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotRatio::setRanges%4B295B580122.body preserve=yes
   Real xlow=0.0, xhigh=0.0;
   PlotGroupCreator::determineXRange(plotGroups,&xlow,&xhigh);
  
   PlotRange& rangeVals = rangeSettings();
   rangeVals.ranges.x1 = xlow;
   rangeVals.ranges.x2 = xhigh;
   if (settings.xOption() == CHANNELS)
      rangeVals.xScaleType = PlotStyle::LINEAR;
   else 
      rangeVals.xScaleType = settings.xLog() ? PlotStyle::LOG :
                PlotStyle::LINEAR;
   rangeVals.yScaleType = settings.yLog() ? PlotStyle::LOG :
                PlotStyle::LINEAR;
                
   rangeVals.useRangeFlags = PlotStyle::XMIN + PlotStyle::XMAX;
   
   // Draw a horizontal line at y = 1.0
   rangeVals.horizontalLine.first = true;
   rangeVals.horizontalLine.second = 1.0;
  //## end PlotRatio::setRanges%4B295B580122.body
}

void PlotRatio::makeLabels (const PlotSettings& settings, StandardLabels& labels) const
{
  //## begin PlotRatio::makeLabels%4B295B6B027E.body preserve=yes
   settings.makeXOptionDependentLabel(labels.x);
   labels.y = settings.lookupLabelName("y:ratio");
   labels.title = settings.lookupLabelName("t:ratio");
  //## end PlotRatio::makeLabels%4B295B6B027E.body
}

std::vector<PlotGroup*> PlotRatio::makePlotGroups (const PlotSettings& settings, const std::vector<const PlotGroup*>& donatedPlotGroups)
{
  //## begin PlotRatio::makePlotGroups%4B633BF000D6.body preserve=yes
   // Plot ratio should show different behavior if following an icounts 
   // or data plot.  For example, following icounts it will show a ratio 
   // of the cumulative totals.  To do this, it must make use of the
   // previous plot's donated plot groups.
   std::vector<PlotGroup*> newGroups;
   if (donatedPlotGroups.size())
   {
      for (size_t i=0; i<donatedPlotGroups.size(); ++i)
      {
         const PlotGroup* origGroup = donatedPlotGroups[i];
         PlotGroup* newGroup = new PlotGroup(origGroup->n, 1);
         
         // Need only the x, y, and model[0] vectors from the original group.
         newGroup->xAxis = origGroup->xAxis;
         newGroup->yData = origGroup->yData;
         newGroup->model[0] = origGroup->model[0];
         newGroup->copyAttributes(*origGroup);
         newGroups.push_back(newGroup);
      }
   }
   else
      newGroups = plotGroupStrategy()->createPlotGroups(settings);
   return newGroups;
  //## end PlotRatio::makePlotGroups%4B633BF000D6.body
}

// Additional Declarations
  //## begin PlotRatio%3DAEFC6300E1.declarations preserve=yes
  //## end PlotRatio%3DAEFC6300E1.declarations

//## begin module%3DAF013D01CC.epilog preserve=yes
//## end module%3DAF013D01CC.epilog
